<script lang="ts">
import Vue from 'vue';
import SurveyStatBubble from './survey-stat-bubble.vue';
import ParallaxContainer from './parallax-container.vue';

export default Vue.extend({
  name: 'SurveyRoleBubbles',
  components: {
    SurveyStatBubble,
    ParallaxContainer,
  },
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
  },
});
</script>

<template>
  <section class="survey-role-bubbles">
    <SlpContainer>
      <div
        v-if="data.background"
        class="survey-role-bubbles__background"
        data-aos="zoom-in-up"
        :data-aos-duration="data.aos_duration"
        :data-aos-offset="data.aos_offset"
      >
        <ParallaxContainer :offset="0.02">
          <nuxt-img
            :src="data.background"
            alt=""
            loading="lazy"
            format="webp"
            quality="99"
          />
        </ParallaxContainer>
      </div>
      <SlpTypography variant="heading4-bold" tag="div">
        {{ data.title }}
      </SlpTypography>

      <SlpRow
        class="survey-role-bubbles__row slp-justify-content-center"
        :class="
          data.blocks[0]?.text ? 'survey-role-bubbles__row-text' : undefined
        "
      >
        <SlpColumn
          v-for="block in data.blocks"
          :key="block.label"
          :cols="6"
          class="survey-role-bubbles__col"
          :class="block?.text ? 'survey-role-bubbles__col-text' : undefined"
        >
          <div
            :class="
              block?.text
                ? 'survey-role-bubbles__stat-text'
                : 'survey-role-bubbles__stat'
            "
          >
            <SurveyStatBubble
              :percentage="block.percentage"
              :color="block.color"
              :text-bubble="block?.text"
            />
          </div>
          <SlpTypography
            v-if="block.label && !block.text"
            variant="body2-bold"
            tag="div"
            class="survey-role-bubbles__legend"
            >{{ block.label }}</SlpTypography
          >
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.survey-role-bubbles {
  color: $color-primary-300;
  position: relative;

  &__col {
    width: 50%;
    text-align: center;
    display: flex;
    flex-direction: row;
    align-items: center;
    justify-content: center;
    @media (min-width: $breakpoint-lg) {
      text-align: left;
    }
    .survey-role-bubbles__stat-text {
      :deep {
        .survey-stat-bubble--purple {
          &:before {
            background: radial-gradient(
              40% 40% at 50% 50%,
              rgba(169, 137, 245, 0.5) 0%,
              rgba(169, 137, 245, 0) 100%
            );
          }
        }
        .survey-stat-bubble--green {
          &:before {
            background: radial-gradient(
              40% 40% at 50% 50%,
              rgba(93, 218, 180, 0.5) 0%,
              rgba(93, 218, 180, 0) 100%
            );
          }
        }
        .survey-stat-bubble--yellow {
          &:before {
            background: radial-gradient(
              40% 40% at 50% 50%,
              rgba(252, 161, 33, 0.5) 0%,
              rgba(252, 161, 33, 0) 100%
            );
          }
        }
      }
    }
    &:nth-child(1) {
      order: 2;
      flex-direction: column;
      @media (min-width: $breakpoint-lg) {
        flex-direction: row-reverse;
      }
      @media (min-width: $breakpoint-md) {
        width: 340px;
        margin-right: -80px;
      }
      .survey-role-bubbles__stat,
      .survey-role-bubbles__stat-text {
        margin-right: 0;
        width: 265px;
        flex-shrink: 0;
      }
      :deep {
        .survey-stat-bubble__number * {
          font-size: 48px;
          @media (min-width: $breakpoint-md) {
            font-size: 80px;
          }
        }
        .survey-stat-bubble__text * {
          font-size: 28px;
        }
      }
      .survey-role-bubbles__stat-text {
        width: 640px;
      }
    }
    &-text {
      &:nth-child(1) {
        @media (min-width: $breakpoint-md) {
          margin-right: -140px;
          margin-top: -300px;
        }
      }
    }
    &:nth-child(2) {
      order: 1;
      flex: 0 0 100%;
      max-width: 100%;
      margin-bottom: -15%;
      @media (min-width: $breakpoint-md) {
        margin-bottom: -12%;
        margin-right: -210px;
      }
      .survey-role-bubbles__stat,
      .survey-role-bubbles__stat-text {
        width: 206px;
        flex-shrink: 0;
        :deep {
          .survey-stat-bubble__number * {
            font-size: 48px;
          }
          .survey-stat-bubble__text * {
            font-size: 28px;
          }
        }
      }
      .survey-role-bubbles__stat-text {
        width: 460px;
      }
    }
    &-text {
      &:nth-child(2) {
        @media (min-width: $breakpoint-md) {
          margin-bottom: -17%;
          margin-left: 250px;
        }
      }
    }
    &:nth-child(3) {
      order: 3;
      justify-content: flex-start;
      flex-direction: column;
      @media (min-width: $breakpoint-md) {
        flex-direction: row;
        margin-top: 84px;
      }
      .survey-role-bubbles__stat,
      .survey-role-bubbles__stat-text {
        width: 130px;
        flex-shrink: 0;
        @media (min-width: $breakpoint-md) {
          margin-left: -10px;
        }
        :deep {
          .survey-stat-bubble__number * {
            font-size: 32px;
          }
          .survey-stat-bubble__text * {
            font-size: 28px;
          }
        }
      }
      .survey-role-bubbles__stat-text {
        width: 530px;
      }
    }
  }
  &__stat {
    width: 100%;
    :deep {
      .survey-stat-bubble__number * .survey-stat-bubble__text * {
        font-family: 'GitLab Mono';
      }
    }
  }

  &__legend {
    margin-top: $spacing-4;
  }
  &__background {
    position: absolute;

    top: -59%;
    left: -36%;

    @media (min-width: $breakpoint-md) {
      top: -23%;
      left: 10%;
    }
  }
  &__row-text {
    flex-direction: column;
    align-content: center;
    @media (min-width: $breakpoint-md) {
      flex-direction: initial;
      align-content: initial;
    }
  }
}
</style>
